/*
A basic extension of the com.sun.java.swing.JApplet class
*/

import javax.swing.*;
import java.awt.*;

public class extra extends JApplet {
    public void init() {
	// This line prevents the
	//     "Swing: checked access to system event queue"
	// message seen in some browsers.
	getRootPane().putClientProperty("defeatSystemEventQueueCheck", Boolean.TRUE);

	// This code is automatically generated by Visual Cafe when you add
	// components to the visual environment. It instantiates and initializes
	// the components. To modify the code, only use code syntax that matches
	// what Visual Cafe can generate, or Visual Cafe may be unable to back
	// parse your Java file into its visual environment.

	// This next comment tells VC where the section starts...
	//{{INIT_CONTROLS
	setSize(550,287);	// Applet window size
	getContentPane().setLayout(null);
	getContentPane().setBackground(clrOkay);

	hsbTemp.setBlockIncrement(1);
	hsbTemp.setBounds(132,132,264,28);
	getContentPane().add(hsbTemp);

	rbF2C.setCheckboxGroup(rbGroup1);
	rbF2C.setState(true);
	rbF2C.setLabel("Convert Fahrenheit to Celsius");
	rbF2C.setFont(new Font("Dialog", Font.PLAIN, 14));
	rbF2C.setBounds(156,60,216,24);
	getContentPane().add(rbF2C);

	rbC2F.setCheckboxGroup(rbGroup1);
	rbC2F.setLabel("Convert Celsius to Fahrenheit");
	rbC2F.setFont(new Font("Dialog", Font.PLAIN, 14));
	rbC2F.setBounds(156,96,216,24);
	getContentPane().add(rbC2F);

	lblFahrText.setText("Fahrenheit:");
	lblFahrText.setAlignment(java.awt.Label.RIGHT);
	lblFahrText.setFont(new Font("Dialog", Font.PLAIN, 14));
	lblFahrText.setBounds(192,180,84,24);
	getContentPane().add(lblFahrText);

	lblCelsText.setText("Celsius:");
	lblCelsText.setAlignment(java.awt.Label.RIGHT);
	lblCelsText.setFont(new Font("Dialog", Font.PLAIN, 14));
	lblCelsText.setBounds(192,216,83,24);
	getContentPane().add(lblCelsText);

	lblFahrNum.setText("32");
	lblFahrNum.setFont(new Font("Dialog", Font.PLAIN, 14));
	lblFahrNum.setBounds(288,180,36,24);
	getContentPane().add(lblFahrNum);

	lblCelsNum.setText("0");
	lblCelsNum.setFont(new Font("Dialog", Font.PLAIN, 14));
	lblCelsNum.setBounds(288,216,36,24);
	getContentPane().add(lblCelsNum);
	//}}

	//{{REGISTER_LISTENERS
	SymAdjustment lSymAdjustment = new SymAdjustment();
	hsbTemp.addAdjustmentListener(lSymAdjustment);	// scrollbar changes

	SymItem lSymItem = new SymItem();
	rbF2C.addItemListener(lSymItem);		// radiobutton changes
	rbC2F.addItemListener(lSymItem);
	//}}
    }

    //{{DECLARE_CONTROLS
    java.awt.Scrollbar hsbTemp = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,32,20,-40,232);
    java.awt.CheckboxGroup rbGroup1 = new java.awt.CheckboxGroup();
    java.awt.Checkbox rbF2C = new java.awt.Checkbox();
    java.awt.Checkbox rbC2F = new java.awt.Checkbox();
    java.awt.Label lblFahrText = new java.awt.Label();
    java.awt.Label lblCelsText = new java.awt.Label();
    java.awt.Label lblFahrNum = new java.awt.Label();
    java.awt.Label lblCelsNum = new java.awt.Label();
    java.awt.Color clrCold = new java.awt.Color(0, 0, 255);	// blue
    java.awt.Color clrHot = new java.awt.Color(255, 0, 0);	// red
    java.awt.Color clrOkay = new java.awt.Color(240, 240, 240);	// gray
    //}}

    class SymAdjustment implements java.awt.event.AdjustmentListener {
	public void adjustmentValueChanged(java.awt.event.AdjustmentEvent event) {
	    Object object = event.getSource();
	    if (object == hsbTemp)
		hsbTemp_AdjustmentValueChanged(event);
	}
    }

    void hsbTemp_AdjustmentValueChanged(java.awt.event.AdjustmentEvent event) {
	double fTemp, cTemp;

	if (rbF2C.getState() == true) {	// convert Fahr to Cels...
	    fTemp = hsbTemp.getValue();		// value from scrollbar
	    cTemp = (fTemp - 32) / 1.8;		// calculate celsius
	} else {			// convert Cels to Fahr...
	    cTemp = hsbTemp.getValue();		// value from scrollbar
	    fTemp = cTemp * 1.8 + 32;		// calculate fahrenheit
	}
	lblFahrNum.setText("" + fTemp);	// display numeric values
	lblCelsNum.setText("" + cTemp);

	if (fTemp < 70) {
	    getContentPane().setBackground(clrCold);
	} else if (fTemp > 90) {
	    getContentPane().setBackground(clrHot);
	} else
	    getContentPane().setBackground(clrOkay);

    }

    class SymItem implements java.awt.event.ItemListener {
	public void itemStateChanged(java.awt.event.ItemEvent event) {
	    Object object = event.getSource();
	    if (object == rbF2C)
		rbF2C_ItemStateChanged(event);
	    else if (object == rbC2F)
		rbC2F_ItemStateChanged(event);
	}
    }

    void resetTempBar() {
	if (rbF2C.getState() == true) {
	    double x = hsbTemp.getValue() * 1.8 + 32;
	    hsbTemp.setMaximum(212 + hsbTemp.getVisibleAmount());
	    hsbTemp.setMinimum(-40);
	    hsbTemp.setValue((int)x);
	} else {
	    double x = (hsbTemp.getValue() - 32) / 1.8;
	    hsbTemp.setMaximum(100 + hsbTemp.getVisibleAmount());
	    hsbTemp.setMinimum(-40);
	    hsbTemp.setValue((int)x);
	}
    }

    void rbF2C_ItemStateChanged(java.awt.event.ItemEvent event) {
	resetTempBar();	// If Fahr-to-Cels, change scrollbar limits
    }

    void rbC2F_ItemStateChanged(java.awt.event.ItemEvent event) {
	resetTempBar();	// If Cels-to-Fahr, change scrollbar limits
    }
}
